Index: issm/trunk/src/modules/Kriging/Kriging.cpp
===================================================================
--- issm/trunk/src/modules/Kriging/Kriging.cpp	(revision 12709)
+++ issm/trunk/src/modules/Kriging/Kriging.cpp	(revision 13395)
@@ -4,5 +4,24 @@
 #include "./Kriging.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void KrigingUsage(void){/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("   usage: predictions=" << __FUNCT__ << "(x,y,observations,x_interp,y_interp,'options');");
+	_pprintLine_("   available options:");
+	_pprintLine_("      -'model': Available variogram models 'gaussian' (default),'spherical','power','exponential'");
+	_pprintLine_("         -'nugget': nugget effect (default 0.2)");
+	_pprintLine_("         -'range':  for gaussian, spherical and exponential models (default sqrt(3))");
+	_pprintLine_("         -'sill':   for gaussian, spherical and exponential models (default 1)");
+	_pprintLine_("         -'slope':  for power model (default 1)");
+	_pprintLine_("         -'power':  for power model (default 1)");
+	_pprintLine_("      -'searchradius': search radius for each prediction (default is observations span)");
+	_pprintLine_("      -'boxlength':    minimum length of quadtree boxes (useful to decrease the number of observations)");
+	_pprintLine_("      -'maxdata':      minimum number of observations for a prediction (default is 50)");
+	_pprintLine_("      -'mindata':      maximum number of observations for a prediction (default is 1)");
+	_pprintLine_("      -'maxtrimming':  maximum trimming value (default is -1.e+21)");
+	_pprintLine_("      -'mintrimming':  minimum trimming value (default is +1.e+21)");
+	_pprintLine_("      -'minspacing':   minimum distance between observation (default is 0.01)");
+	_pprintLine_("");
+}/*}}}*/
+WRAPPER(Kriging){
 
 	/*Outputs*/
@@ -22,13 +41,13 @@
 	/*checks on arguments on the matlab side: */
 	if (nrhs<NRHS || nlhs>NLHS){
-		KrigingUsage(); _error2_("Kriging usage error");
+		KrigingUsage(); _error_("Kriging usage error");
 	}
 
 	/*Fetch inputs: */
 	FetchData(&x,&n_obs,X);
-	FetchData(&y,&N,Y);                       if(n_obs!=N) _error2_("x and y should have the same size");
-	FetchData(&observations,&N,OBSERVATIONS); if(n_obs!=N) _error2_("x and observations should have the same size");
+	FetchData(&y,&N,Y);                       if(n_obs!=N) _error_("x and y should have the same size");
+	FetchData(&observations,&N,OBSERVATIONS); if(n_obs!=N) _error_("x and observations should have the same size");
 	FetchData(&x_interp,&M_interp,&N_interp,XINTERP);
-	FetchData(&y_interp,&M,&N,YINTERP);       if(N!=N_interp || M!=M_interp) _error2_("x_interp and y_interp should have the same size");
+	FetchData(&y_interp,&M,&N,YINTERP);       if(N!=N_interp || M!=M_interp) _error_("x_interp and y_interp should have the same size");
 	FetchData(&options,NRHS,nrhs,prhs);
 
@@ -41,33 +60,14 @@
 
 	/*Free ressources: */
-	xfree((void**)&x);
-	xfree((void**)&y);
-	xfree((void**)&observations);
-	xfree((void**)&x_interp);
-	xfree((void**)&y_interp);
-	xfree((void**)&predictions);
-	xfree((void**)&error);
+	xDelete<double>(x);
+	xDelete<double>(y);
+	xDelete<double>(observations);
+	xDelete<double>(x_interp);
+	xDelete<double>(y_interp);
+	xDelete<double>(predictions);
+	xDelete<double>(error);
+	delete options;
 
 	/*end module: */
 	MODULEEND();
 }
-
-void KrigingUsage(void){
-	_pprintLine_("");
-	_pprintLine_("   usage: predictions=" << __FUNCT__ << "(x,y,observations,x_interp,y_interp,'options');");
-	_pprintLine_("   available options:");
-	_pprintLine_("      -'model': Available variogram models 'gaussian' (default),'spherical','power','exponential'");
-	_pprintLine_("         -'nugget': nugget effect (default 0.2)");
-	_pprintLine_("         -'range':  for gaussian, spherical and exponential models (default sqrt(3))");
-	_pprintLine_("         -'sill':   for gaussian, spherical and exponential models (default 1)");
-	_pprintLine_("         -'slope':  for power model (default 1)");
-	_pprintLine_("         -'power':  for power model (default 1)");
-	_pprintLine_("      -'searchradius': search radius for each prediction (default is observations span)");
-	_pprintLine_("      -'boxlength':    minimum length of quadtree boxes (useful to decrease the number of observations)");
-	_pprintLine_("      -'maxdata':      minimum number of observations for a prediction (default is 50)");
-	_pprintLine_("      -'mindata':      maximum number of observations for a prediction (default is 1)");
-	_pprintLine_("      -'maxtrimming':  maximum trimming value (default is -1.e+21)");
-	_pprintLine_("      -'mintrimming':  minimum trimming value (default is +1.e+21)");
-	_pprintLine_("      -'minspacing':   minimum distance between observation (default is 0.01)");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/Kriging/Kriging.h
===================================================================
--- issm/trunk/src/modules/Kriging/Kriging.h	(revision 12709)
+++ issm/trunk/src/modules/Kriging/Kriging.h	(revision 13395)
@@ -1,4 +1,4 @@
 /*
-	KrigingUsage.h
+	Kriging.h
 */
 
@@ -6,6 +6,14 @@
 #define _KRIGING_H_
 
-/* local prototypes: */
-void KrigingUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -16,15 +24,30 @@
 #undef __FUNCT__ 
 #define __FUNCT__  "Kriging"
-    
+
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define X            (mxArray *)prhs[0]
-#define Y            (mxArray *)prhs[1]
-#define OBSERVATIONS (mxArray *)prhs[2]
-#define XINTERP      (mxArray *)prhs[3]
-#define YINTERP      (mxArray *)prhs[4]
+#define X            prhs[0]
+#define Y            prhs[1]
+#define OBSERVATIONS prhs[2]
+#define XINTERP      prhs[3]
+#define YINTERP      prhs[4]
 
 /* serial output macros: */
 #define PREDICTIONS (mxArray**)&plhs[0]
 #define ERROR       (mxArray**)&plhs[1]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define X            PyTuple_GetItem(args,0)
+#define Y            PyTuple_GetItem(args,1)
+#define OBSERVATIONS PyTuple_GetItem(args,2)
+#define XINTERP      PyTuple_GetItem(args,3)
+#define YINTERP      PyTuple_GetItem(args,4)
+
+/* serial output macros: */
+#define PREDICTIONS output,0
+#define ERROR       output,1
+#endif
 
 /* serial arg counts: */
Index: issm/trunk/src/modules/Ll2xy/Ll2xy.cpp
===================================================================
--- issm/trunk/src/modules/Ll2xy/Ll2xy.cpp	(revision 12709)
+++ issm/trunk/src/modules/Ll2xy/Ll2xy.cpp	(revision 13395)
@@ -4,74 +4,5 @@
 #include "./Ll2xy.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
-
-	int i,verbose=1;
-
-	/*input: */
-	double  *lat=NULL,*lon=NULL;
-	int     nlat,nlon,ncoord;
-	int     sgn;
-
-	Options* options=NULL;
-	double   cm=0.,sp=0.;
-
-	/* output: */
-	double  *x=NULL,*y=NULL;
-	int     iret=0;
-
-	/*Boot module: */
-	MODULEBOOT();
-
-	/*checks on arguments on the matlab side: */
-	if (nlhs > NLHS) {
-		Ll2xyUsage(); _error2_("Ll2xy usage error");
-	}
-	if (nrhs < NRHS) {
-		Ll2xyUsage(); _error2_("Ll2xy usage error");
-	}
-
-	/*Input datasets: */
-	FetchData(&lat,&nlat,LAT_IN);
-	FetchData(&lon,&nlon,LON_IN);
-	FetchData(&sgn,SGN_IN);
-	FetchData(&options,NRHS,nrhs,prhs);
-
-	/*  defaults are in Ll2xydef, so don't duplicate them here, and only use user values if both have been specified  */
-	if(options->GetOption("central_meridian") || options->GetOption("standard_parallel")){
-		options->Get(&cm,"central_meridian");
-		if (verbose) _printLine_("  cm=" << cm);
-		options->Get(&sp,"standard_parallel");
-		if (verbose) _printLine_("  sp=" << sp);
-	}
-
-	/*some checks*/
-	if (verbose) _printLine_("Checking inputs:");
-	if (nlat != nlon){_error2_("Must have same number of lat[" << nlat << "] and lon[" << nlon << "] coordinates.");}
-	else                ncoord=nlat;
-	if (sgn != +1 && sgn != -1) _error2_("Hemisphere sgn=" << sgn << " must be +1 (north) or -1 (south).");
-	if (fabs(cm)      > 180.) _error2_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
-	if (sp < 0. || sp >  90.) _error2_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
-
-	x=(double*)mxMalloc(ncoord*sizeof(double));
-	y=(double*)mxMalloc(ncoord*sizeof(double));
-
-	/* Run core computations: */
-	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
-		iret=Ll2xyx(x,y,lat,lon,ncoord,sgn,cm,sp);
-	else
-		iret=Ll2xyx(x,y,lat,lon,ncoord,sgn);
-
-	/*Write data: */
-	WriteData(X_OUT,x,ncoord);
-	WriteData(Y_OUT,y,ncoord);
-
-	/*Clean-up*/
-	delete options;
-
-	/*end module: */
-	MODULEEND();
-}
-
-void Ll2xyUsage(void){
+void Ll2xyUsage(void){/*{{{*/
 	_pprintLine_("Ll2xy - lat/long to x/y coordinate transformation module:");
 	_pprintLine_("");
@@ -96,3 +27,71 @@
 	_pprintLine_("      [x,y]=Ll2xy(lat,lon,-1,'central_meridian', 0,'standard_parallel',71);");
 	_pprintLine_("");
+}/*}}}*/
+WRAPPER(Ll2xy){
+
+	int i,verbose=1;
+
+	/*input: */
+	double  *lat=NULL,*lon=NULL;
+	int     nlat,nlon,ncoord;
+	int     sgn;
+
+	Options* options=NULL;
+	double   cm=0.,sp=0.;
+
+	/* output: */
+	double  *x=NULL,*y=NULL;
+	int     iret=0;
+
+	/*Boot module: */
+	MODULEBOOT();
+
+	/*checks on arguments on the matlab side: */
+	if (nlhs > NLHS) {
+		Ll2xyUsage(); _error_("Ll2xy usage error");
+	}
+	if (nrhs < NRHS) {
+		Ll2xyUsage(); _error_("Ll2xy usage error");
+	}
+
+	/*Input datasets: */
+	FetchData(&lat,&nlat,LAT_IN);
+	FetchData(&lon,&nlon,LON_IN);
+	FetchData(&sgn,SGN_IN);
+	FetchData(&options,NRHS,nrhs,prhs);
+
+	/*  defaults are in Ll2xydef, so don't duplicate them here, and only use user values if both have been specified  */
+	if(options->GetOption("central_meridian") || options->GetOption("standard_parallel")){
+		options->Get(&cm,"central_meridian");
+		if (verbose) _printLine_("  cm=" << cm);
+		options->Get(&sp,"standard_parallel");
+		if (verbose) _printLine_("  sp=" << sp);
+	}
+
+	/*some checks*/
+	if (verbose) _printLine_("Checking inputs:");
+	if (nlat != nlon){_error_("Must have same number of lat[" << nlat << "] and lon[" << nlon << "] coordinates.");}
+	else                ncoord=nlat;
+	if (sgn != +1 && sgn != -1) _error_("Hemisphere sgn=" << sgn << " must be +1 (north) or -1 (south).");
+	if (fabs(cm)      > 180.) _error_("Central meridian cm=" << cm << " must be between -180 (west) and +180 (east) degrees.");
+	if (sp < 0. || sp >  90.) _error_("Standard parallel sp=" << sp << " must be between 0 and 90 degrees (in specified hemisphere).");
+
+	x=(double*)mxMalloc(ncoord*sizeof(double));
+	y=(double*)mxMalloc(ncoord*sizeof(double));
+
+	/* Run core computations: */
+	if (options->GetOption("central_meridian") && options->GetOption("standard_parallel"))
+		iret=Ll2xyx(x,y,lat,lon,ncoord,sgn,cm,sp);
+	else
+		iret=Ll2xyx(x,y,lat,lon,ncoord,sgn);
+
+	/*Write data: */
+	WriteData(X_OUT,x,ncoord);
+	WriteData(Y_OUT,y,ncoord);
+
+	/*Clean-up*/
+	delete options;
+
+	/*end module: */
+	MODULEEND();
 }
Index: issm/trunk/src/modules/Ll2xy/Ll2xy.h
===================================================================
--- issm/trunk/src/modules/Ll2xy/Ll2xy.h	(revision 12709)
+++ issm/trunk/src/modules/Ll2xy/Ll2xy.h	(revision 13395)
@@ -6,6 +6,14 @@
 #define _LL2XY_H
 
-/* local prototypes: */
-void Ll2xyUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -18,13 +26,23 @@
 #define __FUNCT__  "Ll2xy"
 
+#ifdef _HAVE_MATLAB_MODULES_
+/* serial input macros: */
+#define LAT_IN prhs[0]
+#define LON_IN prhs[1]
+#define SGN_IN prhs[2]
+/* serial output macros: */
+#define X_OUT (mxArray**)&plhs[0]
+#define Y_OUT (mxArray**)&plhs[1]
+#endif
 
+#ifdef _HAVE_PYTHON_MODULES_
 /* serial input macros: */
-#define LAT_IN    prhs[0]
-#define LON_IN    prhs[1]
-#define SGN_IN    prhs[2]
-
+#define LAT_IN PyTuple_GetItem(args,0)
+#define LON_IN PyTuple_GetItem(args,1)
+#define SGN_IN PyTuple_GetItem(args,2)
 /* serial output macros: */
-#define X_OUT    (mxArray**)&plhs[0]
-#define Y_OUT    (mxArray**)&plhs[1]
+#define X_OUT output,0
+#define Y_OUT output,1
+#endif
 
 /* serial arg counts: */
@@ -35,3 +53,2 @@
 
 #endif
-
Index: issm/trunk/src/modules/MeshPartition/MeshPartition.cpp
===================================================================
--- issm/trunk/src/modules/MeshPartition/MeshPartition.cpp	(revision 12709)
+++ issm/trunk/src/modules/MeshPartition/MeshPartition.cpp	(revision 13395)
@@ -1,28 +1,17 @@
 /*!\file:  MeshPartition.cpp
  * \brief: partition mesh according to number of areas, using Metis library.
-
-	usage:
-	[element_partitioning,node_partitioning]=MeshPartition(model,numareas)
-	
-	%Info needed from model are the following: 
-	%mesh info: 
-	numberofelements,numberofvertices,elements,elements_width
-	%Non-extruded 2d mesh info
-	nel2d,nods2d,elements2d,
-	%Extruded 2d mesh info
-	nel2d_ext,nods2d_ext,elements2d_ext,
-	%Diverse
-	numberoflayers,dim)
-
-	output:
-	vector of partitioning area numbers, for every element.
-	vector of partitioning area numbers, for every node.
 */
 	
 #include "./MeshPartition.h"
 
-
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]) {
-
+void MeshPartitionUsage(void){/*{{{*/
+	_printLine_("   usage:");
+	_printString_("   [element_partitioning,node_partitioning]=MeshPartition(md.mesh,numpartitions)");
+	_printLine_("   where:");
+	_printLine_("      element_partitioning is a vector of partitioning area numbers, for every element.");
+	_printLine_("      node_partitioning is a vector of partitioning area numbers, for every node.");
+	_printLine_("");
+}/*}}}*/
+WRAPPER(MeshPartition){
 
 	/*Indexing: */
@@ -74,10 +63,10 @@
 
 	/*Post process node_partitioning and element_partitioning to be in double format. Metis needed them in int* format: */
-	element_partitioning=(double*)xmalloc(numberofelements*sizeof(double));
+	element_partitioning=xNew<double>(numberofelements);
 	for (i=0;i<numberofelements;i++){
 		element_partitioning[i]=(double)int_element_partitioning[i]+1; //Metis indexing from 0, matlab from 1.
 	}
 	
-	node_partitioning=(double*)xmalloc(numberofvertices*sizeof(double));
+	node_partitioning=xNew<double>(numberofvertices);
 	for (i=0;i<numberofvertices;i++){
 		node_partitioning[i]=(double)int_node_partitioning[i]+1; //Metis indexing from 0, matlab from 1.
@@ -94,11 +83,2 @@
 	MODULEEND();
 }
-
-void MeshPartitionUsage(void){
-	_printLine_("   usage:");
-	_printString_("   [element_partitioning,node_partitioning]=MeshPartition(md.mesh,numpartitions)");
-	_printLine_("   where:");
-	_printLine_("      element_partitioning is a vector of partitioning area numbers, for every element.");
-	_printLine_("      node_partitioning is a vector of partitioning area numbers, for every node.");
-	_printLine_("");
-}
Index: issm/trunk/src/modules/MeshPartition/MeshPartition.h
===================================================================
--- issm/trunk/src/modules/MeshPartition/MeshPartition.h	(revision 12709)
+++ issm/trunk/src/modules/MeshPartition/MeshPartition.h	(revision 13395)
@@ -1,13 +1,19 @@
-
 /*
 	MeshPartition.h
 */
 
-
 #ifndef _MESHPARTITION_H
 #define _MESHPARTITION_H
 
-/* local prototypes: */
-void MeshPartitionUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -17,17 +23,24 @@
 #include "../../c/issm-binding.h"
 
-#undef CLEANUP
-#define CLEANUP MeshPartitionLocalCleanup();
-
 #undef __FUNCT__ 
 #define __FUNCT__  "MeshPartition"
 
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define MODEL (mxArray*)prhs[0]
-#define NUMAREAS (mxArray*)prhs[1]
-
+#define MODEL    prhs[0]
+#define NUMAREAS prhs[1]
 /* serial output macros: */
 #define ELEMENTPARTITIONING (mxArray**)&plhs[0]
 #define NODEPARTITIONING (mxArray**)&plhs[1]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define MODEL    PyTuple_GetItem(args,0)
+#define NUMAREAS PyTuple_GetItem(args,1)
+/* serial output macros: */
+#define ELEMENTPARTITIONING output,0
+#define NODEPARTITIONING output,1
+#endif
 
 /* serial arg counts: */
Index: issm/trunk/src/modules/MeshProfileIntersection/MeshProfileIntersection.cpp
===================================================================
--- issm/trunk/src/modules/MeshProfileIntersection/MeshProfileIntersection.cpp	(revision 12709)
+++ issm/trunk/src/modules/MeshProfileIntersection/MeshProfileIntersection.cpp	(revision 13395)
@@ -18,5 +18,17 @@
 #include "./MeshProfileIntersection.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]) {
+void MeshProfileIntersectionUsage(void){/*{{{*/
+	_printLine_("   usage:");
+	_printLine_("   [segments]=MeshProfileIntersection(index,x,y,filename);");
+	_printLine_("   where:");
+	_printLine_("   input:");
+	_printLine_("        index,x,y is a triangulation");
+	_printLine_("        filename: name of Argus style .exp file containing the segments (can be groups of disconnected segments)");
+	_printLine_("   output:");
+	_printLine_("        segments: array made of x1,y1,x2,y2,element_id lines (x1,y1) and (x2,y2) are segment extremitis for a segment ");
+	_printLine_("        belonging to the elemnt_id element. there are as many lines in segments as there are segments intersecting the ");
+	_printLine_("        mesh.");
+}/*}}}*/
+WRAPPER(MeshProfileIntersection){
 
 	int i,j;
@@ -34,7 +46,7 @@
 	//contours
 	mxArray*  matlabstructure=NULL;
-	Contour** contours=NULL;
+	Contour<double>** contours=NULL;
 	int       numcontours;
-	Contour*  contouri=NULL;
+	Contour<double>*  contouri=NULL;
 
 	/* output: */
@@ -54,6 +66,6 @@
 	//index
 	FetchData(&double_index,&nel,&dummy,INDEX);
-	if(dummy!=3 && dummy!=6)_error2_("element triangulation should be of 3 or 6 column width!");
-	index=(int*)xmalloc(nel*3*sizeof(int));
+	if(dummy!=3 && dummy!=6)_error_("element triangulation should be of 3 or 6 column width!");
+	index=xNew<int>(nel*3);
 	for(i=0;i<nel;i++){
 		for(j=0;j<3;j++){
@@ -67,8 +79,8 @@
 	//contours
 	numcontours=mxGetNumberOfElements(matlabstructure);
-	contours=(Contour**)xmalloc(numcontours*sizeof(Contour*));
+	contours=xNew<Contour<double>*>(numcontours);
 	for(i=0;i<numcontours;i++){
 		//allocate
-		contouri=(Contour*)xmalloc(sizeof(Contour));
+		contouri=xNew<Contour<double> >(1);
 		//retrieve dimension of this contour.
 		contouri->nods=(int)mxGetScalar(mxGetField(matlabstructure,i,"nods"));
@@ -100,15 +112,2 @@
 
 }
-
-void MeshProfileIntersectionUsage(void){
-	_printLine_("   usage:");
-	_printLine_("   [segments]=MeshProfileIntersection(index,x,y,filename);");
-	_printLine_("   where:");
-	_printLine_("   input:");
-	_printLine_("        index,x,y is a triangulation");
-	_printLine_("        filename: name of Argus style .exp file containing the segments (can be groups of disconnected segments)");
-	_printLine_("   output:");
-	_printLine_("        segments: array made of x1,y1,x2,y2,element_id lines (x1,y1) and (x2,y2) are segment extremitis for a segment ");
-	_printLine_("        belonging to the elemnt_id element. there are as many lines in segments as there are segments intersecting the ");
-	_printLine_("        mesh.");
-}
Index: issm/trunk/src/modules/MeshProfileIntersection/MeshProfileIntersection.h
===================================================================
--- issm/trunk/src/modules/MeshProfileIntersection/MeshProfileIntersection.h	(revision 12709)
+++ issm/trunk/src/modules/MeshProfileIntersection/MeshProfileIntersection.h	(revision 13395)
@@ -1,13 +1,19 @@
-
 /*
 	MeshProfileIntersection.h
 */
 
-
 #ifndef _MESHPROFILEINTERSECTION_H
 #define _MESHPROFILEINTERSECTION_H
 
-/* local prototypes: */
-void MeshProfileIntersectionUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -20,12 +26,23 @@
 #define __FUNCT__ "MeshProfileIntersection"
 
+#ifdef _HAVE_MATLAB_MODULES_
 /* input macros: */
-#define INDEX prhs[0]
-#define X prhs[1]
-#define Y prhs[2]
+#define INDEX    prhs[0]
+#define X        prhs[1]
+#define Y        prhs[2]
 #define FILENAME prhs[3]
-
 /* serial output macros: */
 #define SEGMENTS (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* input macros: */
+#define INDEX    PyTuple_GetItem(args,0)
+#define X        PyTuple_GetItem(args,1)
+#define Y        PyTuple_GetItem(args,2)
+#define FILENAME PyTuple_GetItem(args,3)
+/* serial output macros: */
+#define SEGMENTS output,0
+#endif
 
 /* serial arg counts: */
Index: issm/trunk/src/modules/NodeConnectivity/NodeConnectivity.cpp
===================================================================
--- issm/trunk/src/modules/NodeConnectivity/NodeConnectivity.cpp	(revision 12709)
+++ issm/trunk/src/modules/NodeConnectivity/NodeConnectivity.cpp	(revision 13395)
@@ -5,4 +5,9 @@
 #include "./NodeConnectivity.h"
 
+void NodeConnectivityUsage(void){/*{{{*/
+	_pprintLine_("");
+	_pprintLine_("   usage: connectivity = " << __FUNCT__ << "(elements, numnodes);");
+	_pprintLine_("");
+}/*}}}*/
 WRAPPER(NodeConnectivity){
 
@@ -35,8 +40,2 @@
 	MODULEEND();
 }
-
-void NodeConnectivityUsage(void) {
-	_pprintLine_("");
-	_pprintLine_("   usage: connectivity = " << __FUNCT__ << "(elements, numnodes);");
-	_pprintLine_("");
-}
Index: issm/trunk/src/modules/NodeConnectivity/NodeConnectivity.h
===================================================================
--- issm/trunk/src/modules/NodeConnectivity/NodeConnectivity.h	(revision 12709)
+++ issm/trunk/src/modules/NodeConnectivity/NodeConnectivity.h	(revision 13395)
@@ -9,11 +9,14 @@
 	#include <config.h>
 #else
-#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
 
-/*Very important definition in case we are compiling a python module!: needs to come before header files inclusion*/
+/*For python modules: needs to come before header files inclusion*/
 #ifdef _HAVE_PYTHON_
 #define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
 #endif
+
+#undef __FUNCT__ 
+#define __FUNCT__  "NodeConnectivity"
 
 /*Header files: */
@@ -30,6 +33,6 @@
 #ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define ELEMENTS (mxArray*)prhs[0]
-#define NUMNODES (mxArray*)prhs[1]
+#define ELEMENTS prhs[0]
+#define NUMNODES prhs[1]
 /* serial output macros: */
 #define CONNECTIVITY (mxArray**)&plhs[0]
@@ -44,7 +47,4 @@
 #endif
 
-#undef __FUNCT__ 
-#define __FUNCT__  "NodeConnectivity"
-
 /* serial arg counts: */
 #undef NLHS
@@ -53,6 +53,3 @@
 #define NRHS  2
 
-/* local prototypes: */
-void NodeConnectivityUsage(void);
-
 #endif  /* _NODECONNECTIVITY_H */
Index: issm/trunk/src/modules/PointCloudFindNeighbors/PointCloudFindNeighbors.cpp
===================================================================
--- issm/trunk/src/modules/PointCloudFindNeighbors/PointCloudFindNeighbors.cpp	(revision 12709)
+++ issm/trunk/src/modules/PointCloudFindNeighbors/PointCloudFindNeighbors.cpp	(revision 13395)
@@ -5,11 +5,21 @@
 #include "./PointCloudFindNeighbors.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]) {
+void PointCloudFindNeighborsUsage(void){/*{{{*/
+	_printLine_("   usage:");
+	_printLine_("   [flags]=PointCloudFindNeighbors(x,y,mindistance,multithread);\n");
+	_printLine_("   where:");
+	_printLine_("      x,y: list of points.");
+	_printLine_("      mindistance: minimum distance that should exist between points in the cloud.");
+	_printLine_("      multithread: run multithreaded or not. with multithreads, flags can get 1 and 2 values in duplicates.");
+	_printLine_("      flags: array of flags (flag==1 means point is within mindistance of another point)");
+	_printLine_("");
+}/*}}}*/
+WRAPPER(PointCloudFindNeighbors){
 
 	int i,j;
 
 	/* required input: */
-	double* x=NULL;
-	double* y=NULL;
+	double *x = NULL;
+	double *y = NULL;
 	int     nods;
 	double  mindistance;
@@ -17,5 +27,5 @@
 
 	/* output: */
-	Vector*  flags=NULL;
+	SeqVec<double> *flags = NULL;
 
 	/*Boot module: */
@@ -40,13 +50,2 @@
 	MODULEEND();
 }
-
-void PointCloudFindNeighborsUsage(void){
-	_printLine_("   usage:");
-	_printLine_("   [flags]=PointCloudFindNeighbors(x,y,mindistance,multithread);\n");
-	_printLine_("   where:");
-	_printLine_("      x,y: list of points.");
-	_printLine_("      mindistance: minimum distance that should exist between points in the cloud.");
-	_printLine_("      multithread: run multithreaded or not. with multithreads, flags can get 1 and 2 values in duplicates.");
-	_printLine_("      flags: array of flags (flag==1 means point is within mindistance of another point)");
-	_printLine_("");
-}
Index: issm/trunk/src/modules/PointCloudFindNeighbors/PointCloudFindNeighbors.h
===================================================================
--- issm/trunk/src/modules/PointCloudFindNeighbors/PointCloudFindNeighbors.h	(revision 12709)
+++ issm/trunk/src/modules/PointCloudFindNeighbors/PointCloudFindNeighbors.h	(revision 13395)
@@ -1,13 +1,19 @@
-
 /*
 	PointCloudFindNeighbors.h
 */
 
-
 #ifndef _POINTCLOUDFINDNEIGHBORS_H
 #define _POINTCLOUDFINDNEIGHBORS_H
 
-/* local prototypes: */
-void PointCloudFindNeighborsUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -20,17 +26,23 @@
 #define __FUNCT__ "PointCloudFindNeighbors"
 
-
-#ifndef ALL
-#define ALL 0
+#ifdef _HAVE_MATLAB_MODULES_
+/* input macros: */
+#define XHANDLE     prhs[0]
+#define YHANDLE     prhs[1]
+#define MINDISTANCE prhs[2]
+#define MULTITHREAD prhs[3]
+/* serial output macros: */
+#define FLAGS (mxArray**)&plhs[0]
 #endif
 
+#ifdef _HAVE_PYTHON_MODULES_
 /* input macros: */
-#define XHANDLE prhs[0]
-#define YHANDLE prhs[1]
-#define MINDISTANCE prhs[2]
-#define MULTITHREAD prhs[3]
-
+#define XHANDLE     PyTuple_GetItem(args,0)
+#define YHANDLE     PyTuple_GetItem(args,1)
+#define MINDISTANCE PyTuple_GetItem(args,2)
+#define MULTITHREAD PyTuple_GetItem(args,3)
 /* serial output macros: */
-#define FLAGS (mxArray**)&plhs[0]
+#define FLAGS output,0
+#endif
 
 /* serial arg counts: */
@@ -40,5 +52,3 @@
 #define NRHS 4
 
-
 #endif  /* _POINTCLOUDFINDNEIGHBORS_H */
-
Index: issm/trunk/src/modules/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp
===================================================================
--- issm/trunk/src/modules/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp	(revision 12709)
+++ issm/trunk/src/modules/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp	(revision 13395)
@@ -5,5 +5,10 @@
 #include "./PropagateFlagsFromConnectivity.h"
 
-void mexFunction( int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[]){
+void PropagateFlagsFromConnectivityUsage(void) {/*{{{*/
+	_printLine_("");
+	_printLine_("   usage: [pool] = " << __FUNCT__ << "(connectivity,pool,index,flags);");;
+	_printLine_("");
+}/*}}}*/
+WRAPPER(PropagateFlagsFromConnectivity){
 
 	/*input/output datasets: */
@@ -34,14 +39,8 @@
 
 	/*Free ressources: */
-	xfree((void**)&connectivity);
-	xfree((void**)&flags);
+	xDelete<double>(connectivity);
+	xDelete<double>(flags);
 
 	/*end module: */
 	MODULEEND();
 }
-
-void PropagateFlagsFromConnectivityUsage(void) {
-	_printLine_("");
-	_printLine_("   usage: [pool] = " << __FUNCT__ << "(connectivity,pool,index,flags);");;
-	_printLine_("");
-}
Index: issm/trunk/src/modules/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.h
===================================================================
--- issm/trunk/src/modules/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.h	(revision 12709)
+++ issm/trunk/src/modules/PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.h	(revision 13395)
@@ -1,13 +1,19 @@
-
 /*
 	PropagateFlagsFromConnectivity.h
 */
 
-
 #ifndef _PROPAGATEFLAGSFROMCONNECTIVITY_H
 #define _PROPAGATEFLAGSFROMCONNECTIVITY_H
 
-/* local prototypes: */
-void PropagateFlagsFromConnectivityUsage(void);
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+	#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*For python modules: needs to come before header files inclusion*/
+#ifdef _HAVE_PYTHON_
+#define PY_ARRAY_UNIQUE_SYMBOL PythonIOSymbol
+#endif
 
 #include "../../c/include/globals.h"
@@ -20,12 +26,23 @@
 #define __FUNCT__  "PropagateFlagsFromConnectivity"
 
+#ifdef _HAVE_MATLAB_MODULES_
 /* serial input macros: */
-#define CONNECTIVITY (mxArray*)prhs[0]
-#define POOL (mxArray*)prhs[1]
-#define INDEX (mxArray*)prhs[2]
-#define FLAGS (mxArray*)prhs[3]
-
+#define CONNECTIVITY prhs[0]
+#define POOL         prhs[1]
+#define INDEX        prhs[2]
+#define FLAGS        prhs[3]
 /* serial output macros: */
 #define POOLOUT (mxArray**)&plhs[0]
+#endif
+
+#ifdef _HAVE_PYTHON_MODULES_
+/* serial input macros: */
+#define CONNECTIVITY PyTuple_GetItem(args,0)
+#define POOL         PyTuple_GetItem(args,1)
+#define INDEX        PyTuple_GetItem(args,2)
+#define FLAGS        PyTuple_GetItem(args,3)
+/* serial output macros: */
+#define POOLOUT output,0
+#endif
 
 /* serial arg counts: */
@@ -35,6 +52,3 @@
 #define NRHS  4
 
-
 #endif  /* _PROPAGATEFLAGSFROMCONNECTIVITY_H */
-
-
